org.apache.commons.collections4.splitmap

## Class TransformedSplitMap<J,K,U,V>

- java.lang.Object
- - org.apache.commons.collections4.splitmap.AbstractIterableGetMapDecorator<K,V>
  - - org.apache.commons.collections4.splitmap.TransformedSplitMap<J,K,U,V>

- Type Parameters:
    `J` - the type of the keys to put in this map
    `K` - the type of the keys to get in this map
    `U` - the type of the values to put in this map
    `V` - the type of the values to get in this map
  All Implemented Interfaces:
    Serializable, Get<K,V>, IterableGet<K,V>, Put<J,U>

      public class TransformedSplitMap<J,K,U,V>
      extends AbstractIterableGetMapDecorator<K,V>
      implements Put<J,U>, Serializable

  Decorates another `Map` to transform objects that are added.

  The Map put methods and Map.Entry setValue method are affected by this class. Thus objects must be removed or searched for using their transformed form. For example, if the transformation converts Strings to Integers, you must use the Integer form to remove objects.

  Note that TransformedMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedMap(Map)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

  The "put" and "get" type constraints of this class are mutually independent; contrast with `TransformedMap` which, by virtue of its implementing `Map`<K, V>, must be constructed in such a way that its read and write parameters are generalized to a common (super-)type. In practice this would often mean `>Object, Object>`, defeating much of the usefulness of having parameterized types.

  On the downside, this class is not drop-in compatible with `Map` but is intended to be worked with either directly or by `Put` and `Get` generalizations.

  Since:
    4.0
  See Also:
    `SplitMapUtils.readableMap(org.apache.commons.collections4.Get)`, `SplitMapUtils.writableMap(Put)`, Serialized Form

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `TransformedSplitMap(Map<K,V> map, Transformer<? super J,? extends K> keyTransformer, Transformer<? super U,? extends V> valueTransformer)` Constructor that wraps (not copies).

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected V` | `checkSetValue(U value)` Override to transform the value when using `setValue`.
    `void` | `clear()`
    `V` | `put(J key, U value)` Note that the return type is Object, rather than V as in the Map interface.
    `void` | `putAll(Map<? extends J,? extends U> mapToCopy)`
    `static <J,K,U,V> TransformedSplitMap<J,K,U,V>` | `transformingMap(Map<K,V> map, Transformer<? super J,? extends K> keyTransformer, Transformer<? super U,? extends V> valueTransformer)` Factory method to create a transforming map.
    `protected K` | `transformKey(J object)` Transforms a key.
    `protected Map<K,V>` | `transformMap(Map<? extends J,? extends U> map)` Transforms a map.
    `protected V` | `transformValue(U object)` Transforms a value.

    - ### Methods inherited from class org.apache.commons.collections4.splitmap.AbstractIterableGetMapDecorator

      `containsKey, containsValue, decorated, entrySet, equals, get, hashCode, isEmpty, keySet, mapIterator, remove, size, toString, values`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### TransformedSplitMap

          protected TransformedSplitMap(Map<K,V> map,
                                        Transformer<? super J,? extends K> keyTransformer,
                                        Transformer<? super U,? extends V> valueTransformer)

      Constructor that wraps (not copies).

      If there are any elements already in the collection being decorated, they are NOT transformed.

      Parameters:
        `map` - the map to decorate, must not be null
        `keyTransformer` - the transformer to use for key conversion, must not be null
        `valueTransformer` - the transformer to use for value conversion, must not be null
      Throws:
        `NullPointerException` - if map or either of the transformers is null

  - ### Method Detail

    - #### transformingMap

          public static <J,K,U,V> TransformedSplitMap<J,K,U,V> transformingMap(Map<K,V> map,
                                                                               Transformer<? super J,? extends K> keyTransformer,
                                                                               Transformer<? super U,? extends V> valueTransformer)

      Factory method to create a transforming map.

      If there are any elements already in the map being decorated, they are NOT transformed.

      Type Parameters:
        `J` - the input key type
        `K` - the output key type
        `U` - the input value type
        `V` - the output value type
      Parameters:
        `map` - the map to decorate, must not be null
        `keyTransformer` - the transformer to use for key conversion, must not be null
        `valueTransformer` - the transformer to use for value conversion, must not be null
      Returns:
        a new transformed map
      Throws:
        `NullPointerException` - if map or either of the transformers is null

    - #### transformKey

          protected K transformKey(J object)

      Transforms a key.

      The transformer itself may throw an exception if necessary.

      Parameters:
        `object` - the object to transform
      Returns:
        the transformed object

    - #### transformValue

          protected V transformValue(U object)

      Transforms a value.

      The transformer itself may throw an exception if necessary.

      Parameters:
        `object` - the object to transform
      Returns:
        the transformed object

    - #### transformMap

          protected Map<K,V> transformMap(Map<? extends J,? extends U> map)

      Transforms a map.

      The transformer itself may throw an exception if necessary.

      Parameters:
        `map` - the map to transform
      Returns:
        the transformed object

    - #### checkSetValue

          protected V checkSetValue(U value)

      Override to transform the value when using `setValue`.
      Parameters:
        `value` - the value to transform
      Returns:
        the transformed value

    - #### put

          public V put(J key,
                       U value)

      Description copied from interface: `Put`
      Note that the return type is Object, rather than V as in the Map interface. See the class Javadoc for further info.
      Specified by:
        `put` in interface `Put<J,U>`
      Parameters:
        `key` - key with which the specified value is to be associated
        `value` - value to be associated with the specified key
      Returns:
        the previous value associated with `key`, or `null` if there was no mapping for `key`. (A `null` return can also indicate that the map previously associated `null` with `key`, if the implementation supports `null` values.)
      See Also:
        `Map.put(Object, Object)`

    - #### putAll

          public void putAll(Map<? extends J,? extends U> mapToCopy)

      Specified by:
        `putAll` in interface `Put<J,U>`
      Parameters:
        `mapToCopy` - mappings to be stored in this map
      See Also:
        `Map.putAll(Map)`

    - #### clear

          public void clear()

      Specified by:
        `clear` in interface `Put<J,U>`
      See Also:
        `Map.clear()`

Copyright © 2001–2019 The Apache Software Foundation. All rights reserved.